#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long long ll;

const ll INF = 1e18, MAXN = 2e5;

random_device rd;
mt19937_64 rnd(rd());

struct node{
    int v, l, r;
    int p = -1;
};

vector<node> tree(4 * MAXN);
vector<int> h, c;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = {INF, l, r};
        return;
    }
    int m = (r + l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = {INF, l, r};
}

void push(int v) {
    if (tree[v].p == -1 || tree[v].r - tree[v].l == 1) {
        tree[v].p = -1;
        return;
    }
    tree[2 * v + 1].p = tree[2 * v + 2].p = tree[v].p;
    tree[2 * v + 1].v = tree[2 * v + 2].v = tree[v].p;
}

void update(int v, int l, int r, int x) {
    push(v);
    if (tree[v].r <= r && tree[v].l >= l && tree[v].v >= x) {
        tree[v].p = tree[v].v = x;
        push(v);
        return;
    }
    if (tree[v].r <= l || tree[v].l >= r) {
        return;
    }
    update(2 * v + 1, l, r, x);
    update(2 * v + 2, l, r, x);
    tree[v].v = min(tree[2 * v + 1].v, tree[2 * v + 2].v);
}

int get(int v, int l, int r) {
    push(v);
    if (tree[v].r <= r && tree[v].l >= l) {
        return tree[v].v;
    }
    if (tree[v].r <= l || tree[v].l >= r) {
        return INF;
    }
    return min(get(2 * v + 1, l, r), get(2 * v + 2, l, r));
}

void solve() {
    int n;
    cin >> n;
    h.resize(n);
    for (int &e : h) {
        cin >> e;
    }
    c.resize(n);
    for (int &e : c) {
        cin >> e;
    }
    build(0, 0, n);
    stack<int> st;
    vector<int> mxl(n), mxr(n);
    st.push(0);
    mxl[0] = -1;
    for (int i = 1; i < n; i++) {
        while (!st.empty() && h[st.top()] < h[i]) {
            st.pop();
        }
        if (!st.empty()) {
            mxl[i] = st.top();
        } else {
            mxl[i] = -1;
        }
        st.push(i);
    }
    while (!st.empty()) {
        st.pop();
    }
    mxr[n - 1] = n;
    st.push(n - 1);
    for (int i = n - 2; i >= 0; i--) {
        while (!st.empty() && h[st.top()] < h[i]) {
            st.pop();
        }
        if (!st.empty()) {
            mxr[i] = st.top();
        } else {
            mxr[i] = n;
        }
        st.push(i);
    }
    update(0, 0, mxr[0], c[0]);
    for (int i = 1; i < n; i++) {
        int left = mxl[i] + 1, right = mxr[i];
        int mn = get(0, left, i + 1) + c[i];
//        cout << mn << ' ' << left << ' ' << right << '\n';
        update(0, left, right, mn);
    }
    cout << get(0, n - 1, n);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
