#include <bits/stdc++.h>

using namespace std;

#define line cout<<'\n';
#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (a.size())

const long long inf = 9099999999999999999;
const long long mod = 1e9 + 7;
const long long nmax = 2e5 + 100;

struct segmenttree {
    int N;
    vector<int> tree, p;

    segmenttree() {}

    segmenttree(int n) {
        tree.assign(8 * nmax, inf);
        p.assign(8 * nmax, inf);
    }

    void push(int v) {
        if (p[v] == inf) return;

        tree[v] = min(tree[v], p[v]);
        tree[v * 2] = min(tree[v * 2], p[v]);
        tree[v * 2 + 1] = min(tree[v * 2 + 1], p[v]);

        if (v * 2 + 1 >= sz(p))
            return;

        p[v * 2] = min(p[v * 2], p[v]);
        p[v * 2 + 1] = min(p[v * 2 + 1], p[v]);
        p[v] = inf;
    }

    void upd(int v, int tl, int tr, int ql, int qr, int val) {
        push(v);

        if (tr <= ql || qr <= tl) return;
        if (ql <= tl && tr <= qr) {
            p[v] = min(p[v], val);
            push(v);
            return;
        }

        int tm = (tl + tr) / 2;
        upd(v * 2, tl, tm, ql, qr, val);
        upd(v * 2 + 1, tm, tr, ql, qr, val);
        tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
    }

    int get(int v, int tl, int tr, int ql, int qr) {
        push(v);

        if (qr <= tl || tr <= ql) return inf;
        if (ql <= tl && tr <= qr) return tree[v];

        int tm = (tl + tr) / 2;
        return min(get(v * 2, tl, tm, ql, qr), get(v * 2 + 1, tm, tr, ql, qr));
    }

    void upd(int l, int r, int val) {
        upd(1, 1, nmax, l, r + 1, val);
    }

    int get(int l, int r) {
        return get(1, 1, nmax, l, r + 1);
    }
};

void runtimeerror() {
    int n;
    cin >> n;
    vector<int> h(n + 1, 0), c(n + 1, inf);
    for (int i = 1; i <= n; i++)
        cin >> h[i];
    for (int i = 1; i <= n; i++)
        cin >> c[i];

    vector<int> mxl(n + 1), mxr(n + 1);
    stack<pair<int, int>> st;
    st.push({0, inf});
    for (int i = 1; i <= n; i++) {
        while (st.top().second < h[i]) st.pop();
        mxl[i] = st.top().first;
        st.push({i, h[i]});
    }
    while (!st.empty()) st.pop();

    st.push({n + 1, inf});
    for (int i = n; i >= 1; i--) {
        while (st.top().second < h[i]) st.pop();
        mxr[i] = st.top().first;
        st.push({i, h[i]});
    }

    segmenttree dp(n);

    dp.upd(1, 1, 0);
    for (int i = 1; i <= n; i++) {
        int add = dp.get(mxl[i] + 1, i) + c[i];
        int mn = dp.get(i, i);
        dp.upd(i + 1, i + 1, add);
        dp.upd(i + 2, mxr[i], mn + c[i]);
    }

    cout << dp.get(n + 1, n + 1);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tests = 1;
//    cin >> tests;
    while(tests--)
        runtimeerror();
    // cout << "WINNER";
    // I'm stupid man
    return 0;
}
