#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long long ll;
typedef long double ld;

const ll INF = 1e18, MAXN = 2e5;

random_device rd;
mt19937_64 rnd(rd());

struct event{
    int d, w;
};

bool cmp(event a, event b) {
    if (a.d == b.d) {
        return a.w < b.w;
    }
    return a.d < b.d;
}

ld binpow(ld x, int n) {
    ld res = 1;
    while (n) {
        if (n & 1) {
            res *= x;
        }
        x *= x;
        n /= 2;
    }
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<event> a(n + m);
    ld r;
    cin >> r;
    for (int i = 0; i < n; i++) {
        cin >> a[i].d >> a[i].w;
    }
    vector<ld> ans(m);
    for (int i = n; i < n + m; i++) {
        cin >> a[i].d;
        a[i].w = i - n + INF;
    }
    sort(a.begin(), a.end(), cmp);
    ld cur = 0;
    if (a[0].w < INF) {
        cur = a[0].w * r;
    } else {
        ans[a[0].w - INF] = 0;
    }
    int day = a[0].d;
    for (int i = 1; i < n + m; i++) {
        if (day == a[i].d) {
            ans[a[i].w - INF] = cur;
        } else if (day + 1 == a[i].d) {
            cur = cur * (1 - r);
            if (a[i].w < INF) {
                cur += r * a[i].w;
            } else {
                ans[a[i].w - INF] = cur;
            }
        } else {
            cur = cur * binpow(1 - r, a[i].d - day);
            if (a[i].w < INF) {
                cur += r * a[i].w;
            } else {
                ans[a[i].w - INF] = cur;
            }
        }
        day = a[i].d;
    }
    cout << fixed << setprecision(10);
    for (auto &e : ans) {
        cout << e << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
