﻿#include <iostream>
#include <map>
#include<set>
#include <vector>
#include <algorithm>

#include <iomanip>
using namespace std;

struct tree {
	long long n;
	vector<pair<long long, long long>> z;
	tree(long long _n) {
		n = _n;
		z.assign(n * 4, { 0, 0 });
	}

	long long val, poz;
	void upd0(long long l, long long r, long long x) {
		if (l + 1 == r) {
			z[x] = { val, poz };
			return;
		}
		long long m = (l + r) / 2;
		if (poz < m) {
			upd0(l, m, x * 2);
		}
		else upd0(m, r, x * 2 + 1);
		z[x] = max(z[x * 2], z[x * 2 + 1]);
	}
	void upd(long long _poz, long long _val) {
		poz = _poz;
		val = _val;
		upd0(0, n, 1);
	}

	long long lq, rq;
	void get0(long long l, long long r, long long x) {
		if (l >= lq && r <= rq) {
			z[0] = min(z[0], z[x]);
			return;
		}
		long long m = (l + r) / 2;
		if (m > lq) {
			get0(l, m, x * 2);
		}
		if (m < rq) {
			get0(m, r, x * 2 + 1);
		}
	}
	long long get(long long _lq, long long _rq) {
		lq = _lq;
		rq = _rq;
		z[0] = { 1e9, -1 };
		get0(0, n, 1);
		return z[0].second;
	}
};

tree T(0);
vector<long long> z;

long long f(long long l, long long r) {
	if (l >= r) return 0;
	auto q = T.get(l, r);
	long long ans = z[q];
	long long q1 = f(l, q), q2 = f(q + 1, r);
	return ans + min(q1, q2);
}

signed main() {
	long long n;
	cin >> n;
	T = tree(n);
	z.resize(n);
	for (long long i = 0; i < n; i++) {
		long long a = 0;
		cin >> a;
		T.upd(i, a);
	}
	for (auto& i : z) cin >> i;
	cout << f(0, n);
}