#include <bits/stdc++.h>

using namespace std;
#define int long long

struct SegTree {
    vector <pair<int, int>> t;
    int N = 1;

    SegTree(int n) {
        while (N < n) N *= 2;
        t.resize(N * 2, {(int) 1e18, 0});
    }

    void update(int i, int val) {
        i += N;
        t[i] = {val, i - N};
        i /= 2;
        while (i > 0) {
            t[i] = min(t[i * 2], t[i * 2 + 1]);
            i /= 2;
        }
    }

    pair<int, int> get_min(int l, int r) {
        int mn = (int) 1e18, ind = 0;
        for (l += N, r += N; l <= r; l /= 2, r /= 2) {
            if (l % 2 == 1) {
                if (t[l].first < mn)
                    mn = t[l].first, ind = t[l].second;
                l++;
            }
            if (r % 2 == 0) {
                if (t[r].first < mn)
                    mn = t[r].first, ind = t[r].second;
                r--;
            }
        }
        return {mn, ind};
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n;
    cin >> n;
    int h[n], c[n];
    for (int i = 0; i < n; i++)
        cin >> h[i];
    for (int i = 0; i < n; i++)
        cin >> c[i];
    int left[n];
    for (int i = 0; i < n; i++)left[i] = -1;
    for (int i = 1; i < n; i++) {
        int cur = i - 1;
        while (cur != -1 && h[cur] <= h[i])
            cur = left[cur];
        left[i] = cur;
    }

    SegTree T(n);
    int dp[n][2];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 2; j++)
            dp[i][j] = (int) 1e18;
    }
    dp[0][0] = dp[0][1] = c[0];
    T.update(0, min(dp[0][0], dp[0][1]));
    for (int i = 1; i < n; i++) {
        if (left[i] >= 0)
            dp[i][0] = dp[left[i]][0];
        dp[i][0] = min(dp[i][0], min(dp[i - 1][0], dp[i - 1][1]) + c[i]);
        dp[i][1] = min(dp[i - 1][0], dp[i - 1][1]) + c[i];
        int l = max(left[i], 0ll), r = i - 1;
        if (r >= l)
            dp[i][1] = min(dp[i][1], T.get_min(l, r).first + c[i]);
        if (left[i] == -1)
            dp[i][1] = min(dp[i][1], c[i]);
        T.update(i, min(dp[i][0], dp[i][1]));
    }
    cout << min(dp[n - 1][0], dp[n - 1][1]);
    return 0;
}
