#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()
#define int long long 

const int N = 1e7 + 10;
int L[N], R[N], t[N];
int cur = 0;

void build(int v, int l, int r) {
	cur = max(cur, v);
	if (l == r) {
		return;
	}
	L[v] = v * 2, R[v] = v * 2 + 1;
	int m = (l + r) / 2;
	build(2 * v, l, m), build(2 * v + 1, m + 1, r);
}

int update(int v, int l, int r, int pos) {	 
	int u = cur++;
	t[u] = t[v];
	L[u] = L[v];
	R[u] = R[v];
	if (l == r) {
		t[u]++;
		return u;
	}
	int m = (l + r) / 2;
	if (pos <= m) {
		L[u] = update(L[v], l, m, pos);
	} else {
		R[u] = update(R[v], m + 1, r, pos);
	}
	t[u] = t[L[u]] + t[R[u]];
	return u;
}

int kth_element(int v, int l, int r, int k) {
	if (l == r) {
		return l;
	}
	int m = (l + r) / 2;
	if (t[L[v]] >= k) {
		return kth_element(L[v], l, m, k);
	} else {
		return kth_element(R[v], m + 1, r, k - t[L[v]]);
	}
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q, k;
    cin >> n >> q >> k;
    k--;
    vector<int> p(n), pos(n);
    for (int i = 0; i < n; i++) {
    	cin >> p[i];
    	p[i]--;
    	pos[p[i]] = i;
    }
    vector<int> l(q), r(q);
    for (int i = 0; i < q; i++) {
    	cin >> l[i] >> r[i];
    	l[i]--, r[i]--;
    }
    build(1, 0, n - 1);
    int root = 1;
    cur++;
    vector<int> true_root(n);
    for (int i = 0; i < n; i++) {
    	root = update(root, 0, n - 1, p[i]);
    	true_root[i] = root;
    }
    for (int i = q - 1; i >= 0; i--) {
    	if (l[i] <= k && k <= r[i]) {
    		int len = r[i] - l[i];
    		int val = kth_element(true_root[len], 0, n - 1, k - l[i] + 1);
    		int j = pos[val];
    		k = l[i] + j;
    	}
    }
    cout << k + 1 << endl;	
    return 0;
}
