#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

const int INF = 1e9;

struct SegTree {
	vector<int> t;
	int n;
	SegTree (int n_) {
		n = 1;
		while (n <= n_) {
			n *= 2;
		}
		t.resize(2 * n, INF);
	}
	void upd(int i, int val) {
		i += n;
		t[i] = min(t[i], val);
		for (; i > 1; i /= 2) {
			t[i / 2] = min(t[i], t[i ^ 1]);
		}
	}
	int get(int l, int r) {
		int ans = INF;
		l += n, r += n + 1;
		while (l < r) {
			if (l & 1) {
				ans = min(ans, t[l++]);
			}
			if (r & 1) {
				ans = min(ans, t[--r]);
			}
			l /= 2, r /= 2;
		}
		return ans;
	}
};

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> h(n + 2), c(n + 1);
    for (int i = 1; i <= n; i++) {
    	cin >> h[i];
    }
    for (int i = 1; i <= n; i++) {
    	cin >> c[i];
    }
    h[0] = INF;
    h.back() = INF;
    deque<int> q;
    vector<int> l(n + 2), r(n + 2);
    for (int i = 0; i < n + 2; i++) {
    	while (q.size() > 0 && h[i] > h[q.back()]) {
    		r[q.back()] = i;
    		q.pop_back();
    	}
    	q.pb(i);
    }
    q.clear();
    for (int i = n + 1; i >= 0; i--) {
    	while (q.size() > 0 && h[i] > h[q.back()]) {
    		l[q.back()] = i;
    		q.pop_back();
    	}
    	q.pb(i);
    }
    SegTree t(n + 1);
    t.upd(0, 0);
    vector<int> dp(n + 1, INF);
    dp[0] = 0;
    for (int i = 1; i <= n; i++) {
    	dp[i] = min(dp[i], t.get(l[i], i) + c[i]);
    	for (int j = i + 1; j < r[i]; j++) {
    		dp[j] = min(dp[j], dp[i - 1] + c[i]);
    	}
    }
    cout << dp[n] << endl;
    return 0;
}
