#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

const int N = (1 << 16), INF = 1e9;
int ind[N];

array<int, 3> decode(vector<pair<int, int>> u) {
	int x = u[0].first, y = u[0].second;
	for (int i = 0; i < u.size(); i++) {
		x = min(x, u[i].first);
		y = min(y, u[i].second);
	}
	int mask = 0;
	for (int i = 0; i < u.size(); i++) {
		u[i].first -= x;
		u[i].second -= y;
		mask += (1 << (u[i].first * 4 + u[i].second));
	}
	return {x, y, ind[mask]};
}

bool is_connected(vector<pair<int, int>> u) {
	sort(all(u));
	u.erase(unique(all(u)), u.end());
	if (u.size() != 4) {
		return 0;
	}
	map<pair<int, int>, int> used, was;
	for (auto p : u) {
		was[p] = 1;
	}
	used[u[0]] = 1;
	deque<pair<int, int>> q{u[0]};
	while (q.size() > 0) {
		int i = q.front().first, j = q.front().second;
		q.pop_front();
		for (int f = -1; f <= 1; f++) {
			for (int s = -1; s <= 1; s++) {
				if (f != 0 && s != 0) continue;
				if (was[make_pair(i + f, j + s)] && !used[make_pair(i + f, j + s)]) {
					used[make_pair(i + f, j + s)] = 1;
					q.pb({i + f, j + s});
				}
			}
		}
	}
	for (auto p : u) {
		if (!used[p]) {
			return 0;
		}
	}
	return 1;
}

vector<array<int, 3>> transition[19];
vector<pair<int, int>> points[19];

void pre_calc() {
	int val = 0;
	for (int mask = 0; mask < (1 << 16); mask++) {
		if (__builtin_popcount(mask) == 4) {
			vector<pair<int, int>> u;
			int x_min = INF, y_min = INF;
			for (int b = 0; b < 16; b++) {
				if (mask & (1 << b)) {
					int x = b / 4;
					int y = b % 4;
					x_min = min(x_min, x);
					y_min = min(y_min, y);
					u.pb({x, y});
				}
			}
			if (x_min == 0 && y_min == 0 && is_connected(u)) {
				points[val] = u;
				ind[mask] = val++;
				vector<vector<char>> z(4, vector<char>(4, '.'));
				for (auto p : u) {
					z[p.first][p.second] = '#';
				}
			}
		}
	}

	for (int v = 0; v < 19; v++) {
		auto u = points[v];
		for (int i = 0; i < 4; i++) {
			for (int x = -1; x <= 1; x++) {
				for (int y = -1; y <= 1; y++) {
					if (x == 0 && y == 0) continue;
					auto new_u = u;
					new_u[i].first += x;
					new_u[i].second += y;
					if (is_connected(new_u)) {
						transition[v].pb(decode(new_u));
					}
				}
			}
		}
		sort(all(transition[v]));
		transition[v].erase(unique(all(transition[v])), transition[v].end());
	}
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    pre_calc();
    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
    	for (int j = 0; j < m; j++) {
    		cin >> a[i][j];
    	}
    }
    vector<vector<vector<int>>> d(n, vector<vector<int>>(m, vector<int>(19, -1)));
    d[0][0][3] = 0;
    deque<array<int, 3>> q{{0, 0, 3}};
    auto check = [&](int x, int y) -> bool {
    	return 0 <= x && x < n && 0 <= y && y < m;
    };
    while (q.size() > 0) {
    	auto [i, j, ind] = q.front();
    	q.pop_front();
    	vector<pair<int, int>> u = points[ind];
    	bool good = 1;
    	for (int p = 0; p < u.size(); p++) {
    		int x = u[p].first + i, y = u[p].second + j;
    		if (!check(x, y) || a[x][y] == '#') {
    			good = 0;
    		}
    	}
    	if (!good) continue;
    	for (auto arr : transition[ind]) {
    		int new_i = i + arr[0], new_j = j + arr[1], new_ind = arr[2];
    		if (check(new_i, new_j) && d[new_i][new_j][new_ind] == -1) {
    			d[new_i][new_j][new_ind] = d[i][j][ind] + 1;
    			q.pb({new_i, new_j, new_ind});
    		}
    	}
    }
    cout << d[n - 2][m - 2][3] << endl;
    return 0;
}
