#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()
#define int long long

const int INF = 2e18;

set<int> not_free;
set<pair<int, int>> free_segs;
set<array<int, 3>> kek;

ll n, k;

void add_seg(int l, int r) {
	int len = r - l + 1;
	free_segs.insert({l, r});
	kek.insert({-((len + 1) / 2), l, r});
}

void del_seg(int l, int r) {
	free_segs.erase({l, r});
}

int find_pos() {
	if (not_free.size() == 0) {
		return 1;
	}
	pair<int, int> p{-INF, INF};
	while (kek.size() > 0) {
		auto [len, l, r] = *kek.begin();
		if (!free_segs.count(make_pair(l, r))) {
            kek.erase({len, l, r});
			continue;
		}
		int pos = (l + r) / 2;
		if (abs(len) > p.first || (abs(len) == p.first && pos < p.second)) {
			p = make_pair(len, pos);
		}
		break;
	}
	if (!not_free.count(1)) {
		int len = *not_free.begin() - 1;
		if (len >= p.first) {
			p = make_pair(len, 1);
		}
	}
	if (!not_free.count(n)) {
		int len = n - *not_free.rbegin();
		if (len > p.first) {
			p = make_pair(len, n);
		}
	}
	return p.second;
}

void add(int i) {
	not_free.insert(i);
	auto seg = *prev(free_segs.upper_bound(make_pair(i, INF)));
	assert(seg.first <= i && i <= seg.second);
	del_seg(seg.first, seg.second);
	if (seg.first < i) {
		add_seg(seg.first, i - 1);
	}
	if (i < seg.second) {
		add_seg(i + 1, seg.second);
	}
}

void del(int i) {
	not_free.erase(i);
	int L = i, R = i;
	if (i + 1 <= n && !not_free.count(i + 1)) {
		auto p = *free_segs.lower_bound({i, 0});
		assert(p.first == i + 1);
		R = p.second;
		del_seg(p.first, p.second);
	}
	if (i - 1 >= 1 && !not_free.count(i - 1)) {
		auto p = *prev(free_segs.lower_bound({i, 0}));
		assert(p.second == i - 1);
		L = p.first;
		del_seg(p.first, p.second);
	}
	add_seg(L, R);
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> k;
    add_seg(1, n);
    vector<int> arr;
    for (int i = 0; i < k; i++) {
    	char c;
    	cin >> c;
    	if (c == '+') {
    		int pos = find_pos();
    		add(pos);
    		arr.pb(pos);
    		cout << pos << endl;
    	} else {
    		int x;
    		cin >> x;
    		x--;
    		assert(arr[x] != -1);
    		int pos = arr[x];
    		del(pos);
    		arr[x] = -1;
    	}
    }
    return 0;
}
