#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<vector<int>> matrix;
vector<vector<bool>> used;

int dfs(int i, int j) {
    used[i][j] = true;
    vector<pair<int, int>> p = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};
    int res = 1;
    for (auto [dx, dy] : p) {
        if (matrix[i + dx][j + dy] && !used[i + dx][j + dy]) {
            res += dfs(i + dx, j + dy);
        }
    }
    return res;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    matrix.resize(12, vector<int> (12, 0));
    used.resize(12, vector<bool> (12, false));
    for (int i = 1; i < 11; i++) {
        for (int j = 1; j < 11; j++) {
            char c;
            cin >> c;
            if (c == '#')
                matrix[i][j] = 1;
        }
    }
    vector<int> ships;
    for (int i = 1; i < 11; i++) {
        for (int j = 1; j < 11; j++) {
            if (!matrix[i][j])
                continue;
            if (matrix[i - 1][j - 1] || matrix[i - 1][j + 1] || matrix[i + 1][j - 1] || matrix[i + 1][j + 1]) {
                cout << "NO";
                return 0;
            }
            if (!used[i][j])
                ships.push_back(dfs(i, j));
        }
    }
    sort(ships.begin(), ships.end());
    if (ships == vector<int>{1, 1, 1, 1, 2, 2, 2, 3, 3, 4})
        cout << "YES";
    else
        cout << "NO";
    return 0;
}
